



/* ******************************************************************************** .
*                         SUPPLEMENTAL MATERIALS FOR                                .
*              MULTIVARIATE DATA ANALYSIS -- EIGHTH EDITION                         .
*                      HAIR, BLACK, BABIN AND ANDERSON                              .
*                                                                                   .
*                        CHAPTER 4 -- CLUSTER ANALYSIS                              .
*                              SAS CODE                                             .
* ********************************************************************************  ./


/ READ HBAT DATA AND DELETE TWO OUTLIER CASES /


/ HIERARCHICAL CLUSTER ANALYSIS /


TITLE1 "Cluster Analysis 5 VAR -- 4 CLUS";


PROC CLUSTER DATA=WORK.HBAT
	METHOD=WARD
	SIMPLE
	CCC
	PSEUDO
	OUTTREE=WORK.CLUSClusterDatahbat(LABEL="Cluster tree data for WORK.hbat")
	PRINT=10
	PLOTS=PSF
	PLOTS=PST2
	PLOTS=CCC
	;
	VAR x6 x8 x12 x15 x18;
	ID id;
	COPY x6 x8 x12 x15 x18 x19 x20 x21 x22 x23;
RUN;

TITLE1 "Cluster Analysis Tree Chart";

PROC TREE DATA=WORK.CLUSClusterDatahbat
	OUT=WORK.TREETreeDatahbat(LABEL="Disjoint cluster data (from PROC TREE) for WORK.hbat")
	NCLUSTERS=4
	;
	COPY x6 x8 x12 x15 x18 x19 x20 x21 x22 x23;
	ID id;
RUN;

