﻿* Encoding: UTF-8.



* ******************************************************************************** .
*                         SUPPLEMENTAL MATERIALS FOR                        .
*              MULTIVARIATE DATA ANALYSIS -- EIGHTH EDITION         .
*                      HAIR, BLACK, BABIN AND ANDERSON                     .
*                                                                                                      .
*                         CHAPTER 7 -- DISCRIMINANT ANALYSIS                .
*                                        SPSS SYNTAX                                       .
* ******************************************************************************** .

* *******************************.
* READ HBAT DATASET .
* *******************************.


GET FILE = 'HBAT.SAV' .

* **********************************************************. 
* Merge 60/40 split variable from file HBAT_SPLITS .
* **********************************************************.


MATCH FILES FILE = *
  /TABLE = 'HBAT_SPLITS.SAV'
  /BY ID .
SORT CASES BY SPLIT60 (A) .
EXECUTE .



TITLE 'TWO GROUP DISCRIMINANT ANALYSIS' .

* TWO GROUP DISCRIMINANT ANALYSIS .

DISCRIMINANT
  /GROUPS=x4 (0 1)
  /VARIABLES=x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18
  /SELECT=split60(0)
  /ANALYSIS ALL
  /SAVE=CLASS SCORES PROBS
   /METHOD=MAHAL
   /FIN= 3.84
   /FOUT= 2.71
  /PRIORS  SIZE
   /HISTORY
  /STATISTICS=MEAN STDDEV UNIVF BOXM COEFF RAW FPAIR TABLE CROSSVALID
  /PLOT=COMBINED SEPARATE MAP
  /PLOT=CASES
  /CLASSIFY=NONMISSING POOLED .


* THREE GROUP DISCRIMINANT ANALYSIS .

TITLE 'THREE GROUP DISCRIMINANT ANALYSIS' .
DISCRIMINANT
  /GROUPS=x1 (1 3)
  /VARIABLES=x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18
  /SELECT=split60(0)
  /ANALYSIS ALL
  /SAVE=CLASS SCORES PROBS
   /METHOD=MAHAL
   /FIN= 3.84
   /FOUT= 2.71
  /PRIORS  SIZE
   /HISTORY
  /STATISTICS=MEAN STDDEV UNIVF BOXM COEFF RAW FPAIR TABLE CROSSVALID
  /ROTATE= COEFF STRUCTURE
  /PLOT=COMBINED SEPARATE MAP cases
  /PLOT=CASES
  /CLASSIFY=NONMISSING POOLED .


