

/* ******************************************************************************** /
/*                         SUPPLEMENTAL MATERIALS FOR                               /
/*              MULTIVARIATE DATA ANALYSIS -- EIGHTH EDITION                        /       
/*                      HAIR, BLACK, BABIN AND ANDERSON                             /
/*                                                                                  /
/*                      CHAPTER 8 -- LOGISTIC REGRESSON                             /
/*                              SAS CODE                                            /
/* ******************************************************************************** /


/* READ HBAT DATASET AND SELECT 60 CASES OF ESTIMATION DATASET -- HBAT60 / .


ODS GRAPHICS ON;


TITLE;
TITLE1 "Logistic Regression Results";
FOOTNOTE;
PROC LOGISTIC DATA=HBAT60
		PLOTS(ONLY)=ODDSRATIO
		PLOTS(ONLY)=ROC
		PLOTS(ONLY)=INFLUENCE
		PLOTS(ONLY)=DFBETAS
		PLOTS(ONLY)=PHAT
		PLOTS(ONLY)=LEVERAGE
		PLOTS(ONLY)=DPC
		PLOTS(ONLY)=EFFECT
                PLOTS (ONLY) = ROC (ID = CUTPOINT)
                PLOTS (LABEL) = ALL
	        ;
	MODEL x4 (Event = 'Outside North America')=x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18		/
		SELECTION=STEPWISE
		SLE=0.05
		SLS=0.1
		INCLUDE=0
		INFLUENCE
		LACKFIT
		AGGREGATE SCALE=NONE
		RSQUARE
		CTABLE
		LINK=LOGIT
		CLPARM=WALD
		CLODDS=WALD
		ALPHA=0.05
                EXPB
                STB
                DETAILS
                ;
                EFFECTPLOT FIT (X = X13);
                EFFECTPLOT FIT (X = X17);
	;
